function redirect(o, w)
	return function(s)
		return stead.call(stead.ref(o), w)
	end
end

parser.ifobj = function(s, w)
	local k, o 
	local n
	for k,o in opairs(objs()) do
		if not isDisabled(o) then
			return w
		end
	end
	return
end
parser.directions = { 
	{"n", "север" };
	{"ne", "северо-восток"};
	{"e", "восток"};
	{"se", "юго-восток"};
	{"s", "юг"};
	{"sw", "юго-запад"};
	{"w", "запад"};
	{"nw","северо-запад"};
	{"d","вниз"};
	{"u","наверх"};
}

parser.events.Wait = [[Проходит немного времени.]]

local function walk_to_obj(s, w)
	if not isRoom(w) and isObject(w) and w.door then
		if w.openable and not w.opened then
			m = stead.call(w, 'when_closed')
			if not m then
				local rc = w:G()
				local closed = ''
				if rc.male then
					closed = 'закрыт.'
				elseif rc.female then
					closed = 'закрыта.'
				else
					closed = 'закрыто.'
				end
				m = parser:cap(w:M 'им')..' '..closed;
			end
			return m;
		end
		m = stead.call(w, 'door_to')
		if not m then
			error ("Wrong direction: "..m);
		end
		walk(m)
	end
end

parser.events.Walk = function(s, w)
	local k,v
	if not isRoom(w) and isObject(w) then
		if w.door then
			return walk_to_obj(s, w)
		end
		return ("Нельзя зайти в "..w:M 'вн'..'.')
	end
	for k,v in ipairs(s.directions) do
		if v[2] == w then
			local m = here()[v[1]..'_to']
			if type(m) == 'string' then
				local w = stead.ref(m)
				if not isRoom(w) then
					return walk_to_obj(s, w)
				end
				return walk(m)
			else
				local r, v = stead.call(here(), v[1]..'_to')
				return r,v
			end
		end
	end
	return "Некуда идти."
end
local function mwalk(d)
	return function(s)
		local k,v
		if here()[d..'_to'] then
			for k,v in ipairs(s.directions) do
				if v[1] == d then
					return '~'..v[2]
				end
			end
		end
	end
end

local putany = function(s)
	if s:word(3) == 'на' then
		return 'PutOn %2 %4 | ReceiveOn %4 %2'
	elseif s:word(3) == 'в' then
		return 'PutIn %2 %4 | Receive %4 %2'
	else
		return 'PutUnder %2 %4 | ReceiveUnder %4 %2'
	end
end

local lookany = function(s)
	if s:word(2) == 'на' then
		return 'LookAt %3'
	elseif s:word(2) == 'в' then
		return 'LookAt %3'
	end
end

local lookobj = function(s)
	if s:word(2) == 'на' then
		return '{obj}вн|{inv}вн'
	elseif s:word(2) == 'в' then
		return '{obj}вн|{inv}вн'
	end
end

local searchany = function(s)
	if s:word(2) == 'на' then
		return 'SearchOn %3'
	elseif s:word(2) == 'в' then
		return 'Search %3'
	else
		return 'SearchUnder %3'
	end
end

local searchobj = function(s)
	if s:word(2) == 'на' then
		return '{obj}пр|{inv}пр'
	elseif s:word(2) == 'в' then
		return '{obj}пр|{inv}пр'
	else
		return '{obj}тв|{inv}тв'
	end
end

local pushobj = function(s)
	if s:word(3) == 'к'  then
		return "{obj}дт"
	elseif s:word(3) == 'на' then
		return "{obj}вн"
	end
end

local walkany = function(s)
	local k,v
	local w = s:object(3)
	if w then
		return "Walk %3"
	end
	w = s:word(3)
	if not w then
		w = s:word(2)
		return "Walk %2"
	else
		return "Walk %3"
	end
end

local walkall = function(s)
	local rc = ''
	if here().n_to or here().ne_to or here().e_to or here().se_to or here().s_to or here().sw_to or here().w_to or here().nw_to then
		rc = 'на|'
	end
	if here().u_to then
		rc = rc..'наверх|'
	end
	if here().d_to then
		rc = rc..'вниз|'
	end
	if #ways() ~= 0 then
		rc = rc..'{way}|'
	end
	if #objs() ~= 0 then
		rc = rc..'в';
	end
	return rc
end

local walkall2 = function(s)
	local k, v
	local rc = ''
	if s:word() == 'вниз' or s:word() == 'наверх' then
		return "{}"
	end
	for k, v in ipairs(s.directions) do
		if here()[v[1].."_to"] then
			if v[2] ~= 'вниз' and v[2] ~= 'наверх' then
				rc = rc..v[2]..'|'
			end
		end
	end
	rc = rc..'{obj}вн'
	return rc
end

game.verbs = {
--	{ "Exam", "~осмотреться" },
	{"Inventory", "инвентарь" },
	{ "Exam %2", "осмотреть", "{}|{obj}вн|{me()}вн" },
	{ "Exam %2", "~изучить", "{obj}вн|{inv}вн" },
	{ "Exam %2", "~исследовать", "{obj}вн|{inv}вн" },

	{ "LookAt %3", "посмотреть", "на|в", "{obj}вн|{inv}вн" },
	{ "LookAt %3", "~смотреть", "на|в", "{obj}вн|{inv}вн" },

	{ searchany, "искать", "на|в|под", searchobj },
	{ 'Search %2', "~обыскать", "{obj}вн|{inv}вн" },

	{ "Open %2 %3|Openby %3 %2", "открыть", "{obj}вн|{inv}вн", "{}|{inv}тв" },
	{ "Close %2", "закрыть", "{obj}вн|{inv}вн" },
	
	{ "Push %2 %4|Moved %4 %2", "толкнуть", "{obj}вн", "{}|к|на", pushobj },
	{ "Push %2 %4|Moved %4 %2", "~двигать", "{obj}вн", "{}|к|на", pushobj },
	{ "Push %2 %4|Moved %4 %2", "~сдвинуть", "{obj}вн", "{}|к|на", pushobj },

	{ "Pull %2", "тянуть", "{obj}вн" },

	{ "Smell %2", "нюхать", "{obj}вн|{inv}вн" },
	{ "Smell %2", "~понюхать", "{obj}вн|{inv}вн" },

	{ "Eat %2", "есть", "{inv}вн" },
	{ "Eat %2", "~съесть", "{inv}вн" },

	{ "PutIn %2 %4|Receive %4 %2", "вставить", "{inv}вн", "в", "{obj}вн|{inv}вн"},
	{ "PutIn %2 %4|Receive %4 %2", "~воткнуть", "{inv}вн", "в", "{obj}вн|{inv}вн"},

	{ putany, "поставить", "{inv}вн", "на|в|под", "{obj}вн|{inv}вн"},
	{ putany, "~положить", "{inv}вн", "на|в|под", "{obj}вн|{inv}вн"},

	{ "Attack %2 %3", "ударить", "{obj}вн", "{}|{inv}тв"},
	{ "Attack %2 %3" , "~бить", "{obj}вн", "{}|{inv}тв" },
	{ "Attack %2 %3", "~разбить", "{obj}вн", "{}|{inv}тв" },
	{ "Attack %2 %3", "~сломать", "{obj}вн", "{}|{inv}тв" },


	{ walkany, "идти", walkall, walkall2 };
	{ walkany, "~зайти", walkall, walkall2 };
	{ walkany, "~залезть", walkall, walkall2 };
	{ walkany, "~лезть", walkall, walkall2 };
	{ walkany, "~забраться", walkall, walkall2 };

	{ "Walk %1", mwalk 'n' };
	{ "Walk %1", mwalk 'ne' };
	{ "Walk %1", mwalk 'e' };
	{ "Walk %1", mwalk 'se' };
	{ "Walk %1", mwalk 's' };
	{ "Walk %1", mwalk 'sw' };
	{ "Walk %1", mwalk 'w' };
	{ "Walk %1", mwalk 'nw' };
	{ "Walk %1", mwalk 'd' };
	{ "Walk %1", mwalk 'u' };
	
	{ "Take %2", "взять", "{obj}вн" },
	{ "Take %2", "~забрать", "{obj}вн" },
	{ function(s)
		if s:word(3) == 'в' then
			return "Drop %2 %4 | Receive %4 %2"
		else
			return "Drop %2 %4 | ReceiveOn %4 %2"
		end
	end, "бросить", "{inv}вн", '{}|в|на', "{obj} вн"},
	{ "Drop %2","~выбросить", "{inv}вн" },
	{ "Remove %2 %3", "извлечь", "{obj}вн", "{}|{inv}тв"},
	{ "Remove %2 %3", "~вытащить", "{obj}вн", "{}|{inv}тв"},
	{ "Wait", "ждать" },
	{ "Wait", "~подождать" },
	{ "Read %2", "читать", "{obj}вн|{inv}вн" };
	{ "Read %2", "~почитать", "{obj}вн|{inv}вн" };
	{ "Read %2", "~прочитать", "{obj}вн|{inv}вн" };
	{ "Tie %2 %4", "привязать", "{inv}вн", "к", "{obj}дт|{inv}дт" };
	{ "TalkTo %3", "говорить", "с", "{obj}тв" };
	{ "TalkTo %3", "~поговорить", "с", "{obj}тв" };
	{ "Give %2 %3|Receive %3 %2", "отдать", "{inv}вн", "{obj}дт" };
	{ "Give %2 %3|Receive %3 %2", "~дать", "{inv}вн", "{obj}дт" };
	{ "Give %2 %3|Receive %3 %2", "~подарить", "{inv}вн", "{obj}дт" };
};

parser.it = function(s, w, nm)
	local rc, n, v

	nm = morph:case2n(nm)

	local a1 = {'он', 'его', 'ему', 'его', 'им', 'нем' };
	local a2 = {'оно', 'его', 'ему', 'его', 'им', 'нем' };
	local a3 = {'она', 'её', 'ей', 'ее', 'ней', 'ней' };
	local a4 = { 'они', 'их', 'им', 'их', 'ими', 'них' };
	
	rc = parser:gender(w)
	if rc.plural then
		v = a4
	elseif rc.male then
		v = a1
	elseif rc.female then
		v = a3
	else
		v = a2
	end
	return v[nm]
end

parser.need = function(s, w)
	local rc
	rc = parser:gender(w)
	if rc.plural then
		return "нужны"
	elseif rc.male then
		return "нужен"
	elseif rc.female then
		return "нужна"
	else
		return "нужно"
	end
end

local person = function(a, b)
	local p
	if not me().person then
		p = 1
	else
		p = me().person;
	end
	if not a then
		return p
	end
	if p == 1 then
		return a
	end
	return b
end

local gen = function (m, f, n)
	if me().male then
		return m
	elseif me().female then
		return f
	else
		return n
	end
end


parser.events.before_Exam = function(self, s)
	if not s then
		stead.need_scene()
		return true
	end
end

parser.events.Give = function(self, s, w)
	if person() == 1 then
		p ("Мне не удалось отдать ", s:M 'вн', " ", w:M 'дт', ".");
	elseif person() == 2 then
		p ("Тебе не удалось отдать ", s:M 'вн', " ", w:M 'дт', ".");
	end
end;

parser.events.Tie = function(self, s, w)
	p ("Бессмысленно привязывать ", s:M 'вн', " к ", w:M 'дт', ".");
end;

parser.events.after_Exam = function(self, s)
	local w = s
	if person() == 1 then
		p ("Я осмотрел ", w:M 'вн', " и не нашёл в ", w:it 'пр', " ничего необычного.");
	else
		p ("Ты осмотрел", gen("", "а", "о")," ", 
			w:M 'вн', 
			" и не ", gen("нашёл", "нашла", "нашло"),
			" в ", w:it 'пр', " ничего необычного.");
	end
	return
end;

parser.events.TalkTo = function(self, w)
	if person() == 1 then
		p (self:cap(w:M 'им'), ' меня игнорирует.');
	else
		p (self:cap(w:M 'им'), ' тебя игнорирует.');
	end
	return
end;

parser.events.Inventory = function(self, s)
	local k,v
	local n = 0
	local m = 0
	local rc = 0
	for k,v in ipairs(inv()) do
		if v ~= parser_menu_items and not v.hidden and not isDisabled(o) then
			n = n + 1
		end
	end
	if n == 0 then 
		return person("У меня с собой ничего нет.", "У тебя с собой ничего нет.");
	end
	if n <= 2 then 
		rc = person("У меня с собой только ",  "У тебя с собой только ");
	else
		rc = person("У меня с собой: ", "У тебя с собой: ");
	end

	for k,v in ipairs(inv()) do
		if v ~= parser_menu_items and not v.hidden and not isDisabled(v) then
			rc = rc .. v:M(); --stead.dispof(v)
			m = m + 1
			if m == n then
				rc = rc..'.'
			elseif m == n - 1 then
				rc = rc..' и ';
			else
				rc = rc..','
			end
		end
	end
	return rc
end

parser.events.Drop = function(self, s, w)
	if not s.dropable then
		local rc = s:G()
		if rc.singular then
			rc = 'может'
		else
			rc = 'могут'
		end
		if person() == 1 then
			p ("Мне ", s:it 'им', ' еще '..rc..' пригодиться.');
		else
			p ("Тебе ", s:it 'им', ' еще '..rc..' пригодиться.');
		end
		return
	end
	if w then
		return "В этом нет смысла."
	end
	drop(s)
	return r, v
end

parser.events.after_Drop = function(self, s, w, t)
	if person() == 1 then
		p ("Я ", gen("выбросил ", "выбросила ", "выбросило "),s:M 'вн',".")
	else
		p ("Ты ", gen("выбросил ", "выбросила ", "выбросило "), s:M 'вн',".")
	end
end

parser.events.Read = function(self, s, ...)
	parser:redirect({ "Exam", s, ... })
--	p ([[На ]]..s:M 'дт'.." ничего не написано.")
end

local function live_act(s, w)
	p (parser:cap(w:M 'дт'), " это не понравится.")
end

parser.events.Take = function(self, s)
	if not s.takeable then
		if s.live then
			live_act(self, s)
			return 
		end
		if person() == 1 then
			p ("Мне не ", parser:need(s), " ", s:M 'им', ".")
		else
			p ("Тебе не ", parser:need(s), " ", s:M 'им', ".")
		end
		return false
	end
	take(s)
end;

parser.events.after_Take = function(self, s)
	if person() == 1 then
		p ("Я забрал ", s:M 'вн', ".");
	else
		p ("Ты забрал ", s:M 'вн', ".");
	end
end;

parser.gensw = function(s, w, a, b, c, d, e, f)
	local rc = parser:gender(w)
	if rc.male then
		if rc.singular then
			rc = a
		else
			rc = d;
		end
	elseif rc.female then
		if rc.singular then
			rc = b;
		else
			rc = e
		end
	else
		if rc.singular then
			rc = c;
		else
			rc = f
		end
	end
	return rc
end

parser.events.Open = function(self, s, w)
	if s.openable then
		if s.opened then
			local rc = parser:gensw(s, "открыт", "открыта", "открыто", "открыты", "открыты", "открыты")
			p (parser:cap(s:M 'им'), " уже ", rc, ".");
			return
		end
		if w then
			return "Может, сделать это проще?"
		end
	else
		p (parser:cap(s:M 'вн'), " нельзя открыть.");
		return
	end
	s.opened = true;
end

parser.events.after_Open = function(self, s)
	if person() == 1 then
		p ("Я открыл ", s:M 'вн', ".");
	else
		p ("Ты открыл ", s:M 'вн', ".");
	end
	s:enable_all()
end;

parser.events.Close = function(self, s)
	if s.openable then
		if not s.opened then
			local rc = parser:gensw(s, "закрыт", "закрыта", "закрыто", "закрыты", "закрыты", "закрыты")
			p (parser:cap(s:M 'им'), " уже ", rc, ".");
			return
		end
		s.opened = false
	else
		p (parser:cap(s:M 'вн'), " нельзя закрыть.");
	end
end;

parser.events.after_Close = function(self, s)
	if person() == 1 then
		p ("Я закрыл ", s:M 'вн', ".");
	else
		p ("Ты закрыл ", s:M 'вн', ".");
	end
	s:disable_all()
end;

parser.events.Push = function(self, s)
	if s.live then
		return live_act(self, s)
	end
end

parser.events.Pull = function(self, s)
	if s.live then
		return live_act(self, s)
	end
end

parser.events.after_Push = function(self, s, w)
	p ([[Нет смысла двигать ]], s:M 'вн', '.')
end

parser.events.after_Pull = function(self, s, w)
	p ([[Нет смысла тянуть ]], s:M 'вн', '.')
end

parser.events.after_Attack = function(self, s, w)
	p ([[Агрессия к ]],  s:M 'дт', [[ не оправдана.]])
	return
end

parser.events.after_LookAt = function(self, s, ...)
	parser:redirect({ "Exam", s, ... })
	return true 
end
parser.events.Search = function(self, s, w)
	if s.live then
		return live_act(self, s)
	end
	return
end
parser.events.SearchOn = parser.events.Search
parser.events.SearchUnder = parser.events.Search

parser.events.after_Search = function(self, s, w)
	if person() == 1 then
		p ([[Я не нахожу в ]],  s:M 'пр', [[ ничего интересного.]])
	else
		p ([[Ты не находишь в ]],  s:M 'пр', [[ ничего интересного.]])
	end
	return
end

parser.events.after_SearchOn = function(self, s, w)
	if person() == 1 then
		p ([[Я не нахожу на ]],  s:M 'пр', [[ ничего интересного.]])
	else
		p ([[Ты не находишь на ]],  s:M 'пр', [[ ничего интересного.]])
	end
	return
end

parser.events.after_SearchUnder = function(self, s, w)
	if person() == 1 then
		p ([[Я не нахожу под ]],  s:M 'тв', [[ ничего интересного.]])
	else
		p ([[Ты не находишь под ]],  s:M 'тв', [[ ничего интересного.]])
	end
	return
end

--parser.events.after_SearchOn = parser.events.after_Search
--parser.events.after_SearchUnder = parser.events.after_Search

parser.events.after_Smell = function(self, s)
	if s.live then
		p [[Никакого необычного запаха нет.]]
		return
	end
	if person() == 1 then
		p ([[Я ]], gen("понюхал", "понюхала", "понюхало"), " ",  s:M 'вн', [[. Пахнет как ]], s:M 'им', '.')
	else
		p ([[Ты ]], gen("понюхал", "понюхала", "понюхало"), " ", s:M 'вн', [[. Пахнет как ]], s:M 'им', '.')
	end
end

parser.events.Remove = function(self, s, w)
	if not w and s.takeable then
		parser:redirect({"Take", s });
		return
	end
	if not s.removable then
		p (self:cap(s:M 'вн')..' нельзя извлечь.')
		if w then
			p ('Тем более '..w:M 'тв'..'.')
		end
		return
	end
	if not w then
		p "Как именно это сделать?"
		return
	end
	if not have(w) then
		if person() == 1 then
			p ("У меня нет "..w:M 'рд'..'.')
		else
			p ("У тебя нет "..w:M 'рд'..'.')
		end
		return
	end
	take(s)
end

parser.events.after_Remove = function(self, s, w)
	if w then
		if person() == 1 then
			p ("Я ", gen("извлек", "извлекла", "извлекло"), " ",s:M 'вн'.." при помощи "..w:M 'рд'..'.')
		else
			p ("Ты ", gen("извлек", "извлекла", "извлекло"), " ",s:M 'вн'.." при помощи "..w:M 'рд'..'.')
		end
		return
	end
	if person() == 1 then
		p ("Я ", gen("взял", "взяла", "взяло"), " ",s:M 'вн');
	else
		p ("Ты ", gen("взял", "взяла", "взяло"), " ", s:M 'вн');
	end
end

parser.events.Eat = function(self, s)
	if not s.eatable then
		if s.live then
			return live_act(self, s)
		end
		if person() == 1 then
			p ("Мне не хочется есть "..s:M 'вн'..'.')
		else
			p ("Тебе не хочется есть "..s:M 'вн'..'.')
		end
		return
	end
	inv():del(s)
end

parser.events.after_Eat = function(self, s)
	if person() == 1 then
		p ([[Я ]], gen("съел", "съела", "съело"), " ",  s:M 'вн', [[.]])
	else
		p ([[Ты ]], gen("съел", "съела", "съело"), " ", s:M 'вн', [[.]])
	end
end

parser.events.PutIn = function(self, s, w)
	if not s.dropable then
		p (parser:cap(s:M 'им')..' еще может пригодиться.')
		return
	end

	if not w then
		p "Куда?"
		return
	end
	if w.container and ( not w.openable or w.opened) then
		put(s, w)
	else
		p("Невозможно поместить "..s:M 'вн'..' в '..w:M 'вн'..'.')
	end
	return r, v
end

parser.events.PutOn = parser.events.PutIn
parser.events.PutUnder = parser.events.PutIn

parser.events.after_PutIn = function(self, s, w)
	if person() == 1 then
		p ([[Я ]], gen("положил", "положила", "положило"), " ", (s:M 'вн')..' в '..(w:M 'вн')..'.')
	else
		p ([[Ты ]], gen("положил", "положила", "положило"), " ",  (s:M 'вн')..' в '..(w:M 'вн')..'.')
	end
end

parser.events.after_PutOn = function(self, s, w)
	if person() == 1 then
		p ([[Я ]], gen("положил", "положила", "положило"), " ",(s:M 'вн')..' на '..(w:M 'вн')..'.')
	else
		p ([[Ты ]], gen("положил", "положила", "положило"), " ",(s:M 'вн')..' на '..(w:M 'вн')..'.')
	end
end

parser.events.after_PutUnder = function(self, s, w)
	if person() == 1 then
		p ([[Я ]], gen("положил", "положила", "положило"), " ",(s:M 'вн')..' под '..(w:M 'вн')..'.')
	else
		p ([[Ты ]], gen("положил", "положила", "положило"), " ",(s:M 'вн')..' под '..(w:M 'вн')..'.')
	end
end


function cutscene(v)
	v.dscs = v.dsc
	v._num = 1;
	v.dsc = function(s)
		p (s.dscs[s._num])
	end;
	v.Next = function(s)
		s._num = s._num + 1;
		if s._num > #s.dscs then
			walk(s.walk_to)
			return
		end
		p (s.dscs[s._num])
	end;
	v.verbs = { 
		{ "Next", "дальше" };
	};
	return room(v);
end

--iam = obj {
--	nam = 'я';
--	morph = {'я', 'меня', 'мне', 'себя', 'мной', 'меня' }; -- осмотреть себя, а не меня
--	attr [[ hidden, ~dropable, live ]];
--}
